/[gentoo-x86]/eclass/linux-mod.eclass
Gentoo

Diff of /eclass/linux-mod.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.70 Revision 1.89
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2004 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-mod.eclass,v 1.70 2007/01/01 22:27:01 swegener Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-mod.eclass,v 1.89 2008/10/31 23:43:48 gengor Exp $
4 4
5# Description: This eclass is used to interface with linux-info in such a way 5# Author(s): John Mylchreest <johnm@gentoo.org>,
6# to provide the functionality required and initial functions 6# Stefan Schweizer <genstef@gentoo.org>
7# required to install external modules against a kernel source 7# Maintainer: kernel-misc@gentoo.org
8# tree.
9#
10# Maintainer: John Mylchreest <johnm@gentoo.org>, Stefan Schweizer <genstef@gentoo.org>
11# Copyright 2004 Gentoo Linux
12# 8#
13# Please direct your bugs to the current eclass maintainer :) 9# Please direct your bugs to the current eclass maintainer :)
10
11# @ECLASS: linux-mod.eclass
12# @MAINTAINER:
13# kernel-misc@gentoo.org
14# @BLURB: It provides the functionality required to install external modules against a kernel source tree.
15# @DESCRIPTION:
16# This eclass is used to interface with linux-info.eclass in such a way
17# to provide the functionality and initial functions
18# required to install external modules against a kernel source
19# tree.
14 20
15# A Couple of env vars are available to effect usage of this eclass 21# A Couple of env vars are available to effect usage of this eclass
16# These are as follows: 22# These are as follows:
17# 23
18# Env Var Option Default Description 24# @ECLASS-VARIABLE: KERNEL_DIR
19# KERNEL_DIR <string> /usr/src/linux The directory containing kernel 25# @DESCRIPTION:
20# the target kernel sources. 26# A string containing the directory of the target kernel sources. The default value is
21# ECONF_PARAMS <string> The parameters to pass to econf. 27# "/usr/src/linux"
28
29# @ECLASS-VARIABLE: ECONF_PARAMS
30# @DESCRIPTION:
31# It's a string containing the parameters to pass to econf.
22# If this is not set, then econf 32# If this is not set, then econf isn't run.
23# isn't run.
24# BUILD_PARAMS <string> The parameters to pass to emake.
25# BUILD_TARGETS <string> clean modules The build targets to pass to
26# make.
27# MODULE_NAMES <string> This is the modules which are
28# to be built automatically using
29# the default pkg_compile/install.
30# They are explained properly
31# below. It will only make
32# BUILD_TARGETS once in any
33# directory.
34 33
35# MODULE_NAMES - Detailed Overview 34# @ECLASS-VARIABLE: BUILD_PARAMS
35# @DESCRIPTION:
36# It's a string with the parameters to pass to emake.
37
38# @ECLASS-VARIABLE: BUILD_TARGETS
39# @DESCRIPTION:
40# It's a string with the build targets to pass to make. The default value is "clean modules"
41
42# @ECLASS-VARIABLE: MODULE_NAMES
43# @DESCRIPTION:
44# It's a string containing the modules to be built automatically using the default
45# src_compile/src_install. It will only make ${BUILD_TARGETS} once in any directory.
46
36# 47#
37# The structure of each MODULE_NAMES entry is as follows: 48# The structure of each MODULE_NAMES entry is as follows:
49#
38# modulename(libdir:srcdir:objdir) 50# modulename(libdir:srcdir:objdir)
51#
52# where:
53#
54# modulename = name of the module file excluding the .ko
55# libdir = place in system modules directory where module is installed:
56# srcdir = place for ebuild to cd to before running make
57# objdir = place the .ko and objects are located after make runs
58#
59# To get an idea of how these variables are used, here's a few lines
60# of code from around line 540 in this eclass:
61#
62# einfo "Installing ${modulename} module"
63# cd ${objdir} || die "${objdir} does not exist"
64# insinto /lib/modules/${KV_FULL}/${libdir}
65# doins ${modulename}.${KV_OBJ} || die "doins ${modulename}.${KV_OBJ} failed"
66#
39# for example: 67# For example:
40# MODULE_NAMES="module_pci(pci:${S}/pci:${S}) module_usb(usb:${S}/usb:${S})" 68# MODULE_NAMES="module_pci(pci:${S}/pci:${S}) module_usb(usb:${S}/usb:${S})"
41# 69#
42# what this would do is 70# what this would do is
71#
43# cd ${S}/pci 72# cd "${S}"/pci
44# make ${BUILD_PARAMS} ${BUILD_TARGETS} 73# make ${BUILD_PARAMS} ${BUILD_TARGETS}
45# cd ${S} 74# cd "${S}"
46# insinto /lib/modules/${KV_FULL}/pci 75# insinto /lib/modules/${KV_FULL}/pci
47# doins module_pci.${KV_OBJ} 76# doins module_pci.${KV_OBJ}
48# 77#
49# cd ${S}/usb 78# cd "${S}"/usb
50# make ${BUILD_PARAMS} ${BUILD_TARGETS} 79# make ${BUILD_PARAMS} ${BUILD_TARGETS}
51# cd ${S} 80# cd "${S}"
52# insinto /lib/modules/${KV_FULL}/usb 81# insinto /lib/modules/${KV_FULL}/usb
53# doins module_usb.${KV_OBJ} 82# doins module_usb.${KV_OBJ}
54#
55# if the srcdir isnt specified, it assumes ${S}
56# if the libdir isnt specified, it assumes misc.
57# if the objdir isnt specified, it assumes srcdir
58 83
59# There is also support for automatyed modules.d file generation. 84# There is also support for automated modprobe.d/modules.d(2.4) file generation.
60# This can be explicitly enabled by setting any of the following variables. 85# This can be explicitly enabled by setting any of the following variables.
86
87# @ECLASS-VARIABLE: MODULESD_<modulename>_ENABLED
88# @DESCRIPTION:
89# This is used to disable the modprobe.d/modules.d file generation otherwise the file will be
90# always generated (unless no MODULESD_<modulename>_* variable is provided). Set to "no" to disable
91# the generation of the file and the installation of the documentation.
92
93# @ECLASS-VARIABLE: MODULESD_<modulename>_EXAMPLES
94# @DESCRIPTION:
95# This is a bash array containing a list of examples which should
96# be used. If you want us to try and take a guess set this to "guess".
61# 97#
98# For each array_component it's added an options line in the modprobe.d/modules.d file
62# 99#
63# MODULESD_${modulename}_ENABLED This enables the modules.d file 100# options array_component
64# generation even if we dont 101#
65# specify any additional info. 102# where array_component is "<modulename> options" (see modprobe.conf(5))
66# MODULESD_${modulename}_EXAMPLES This is a bash array containing 103
67# a list of examples which should 104# @ECLASS-VARIABLE: MODULESD_<modulename>_ALIASES
68# be used. If you want us to try and 105# @DESCRIPTION:
69# take a guess. Set this to "guess" 106# This is a bash array containing a list of associated aliases.
70# MODULESD_${modulename}_ALIASES This is a bash array containing 107#
71# a list of associated aliases. 108# For each array_component it's added an alias line in the modprobe.d/modules.d file
72# MODULESD_${modulename}_ADDITIONS This is a bash array containing 109#
73# A list of additional things to 110# alias array_component
74# add to the bottom of the file. 111#
75# This can be absolutely anything. 112# where array_component is "wildcard <modulename>" (see modprobe.conf(5))
113
114# @ECLASS-VARIABLE: MODULESD_<modulename>_ADDITIONS
115# @DESCRIPTION:
116# This is a bash array containing a list of additional things to
117# add to the bottom of the file. This can be absolutely anything.
76# Each entry is a new line. 118# Each entry is a new line.
77# MODULES_${modulename}_DOCS This is a string list which contains 119
78# the full path to any associated 120# @ECLASS-VARIABLE: MODULESD_<modulename>_DOCS
79# documents for $modulename 121# @DESCRIPTION:
122# This is a string list which contains the full path to any associated
123# documents for <modulename>. These files are installed in the live tree.
124
125# @ECLASS-VARIABLE: KV_OBJ
126# @DESCRIPTION:
127# It's a read-only variable. It contains the extension of the kernel modules.
80 128
81# The order of these is important as both of linux-info and eutils contain 129# The order of these is important as both of linux-info and eutils contain
82# set_arch_to_kernel and set_arch_to_portage functions and the ones in eutils 130# set_arch_to_kernel and set_arch_to_portage functions and the ones in eutils
83# are deprecated in favor of the ones in linux-info. 131# are deprecated in favor of the ones in linux-info.
84# See http://bugs.gentoo.org/show_bug.cgi?id=127506 132# See http://bugs.gentoo.org/show_bug.cgi?id=127506
87EXPORT_FUNCTIONS pkg_setup pkg_preinst pkg_postinst src_install src_compile pkg_postrm 135EXPORT_FUNCTIONS pkg_setup pkg_preinst pkg_postinst src_install src_compile pkg_postrm
88 136
89IUSE="kernel_linux" 137IUSE="kernel_linux"
90SLOT="0" 138SLOT="0"
91DESCRIPTION="Based on the $ECLASS eclass" 139DESCRIPTION="Based on the $ECLASS eclass"
140# Restrict distributed compile of kernel modules bug #167844
141RESTRICT="distcc"
92RDEPEND="kernel_linux? ( virtual/modutils )" 142RDEPEND="kernel_linux? ( virtual/modutils )"
93DEPEND="${RDEPEND} 143DEPEND="${RDEPEND}
94 sys-apps/sed" 144 sys-apps/sed"
95 145
96# eclass utilities 146# eclass utilities
133 ewarn "to match the kernel, or recompile the kernel first." 183 ewarn "to match the kernel, or recompile the kernel first."
134 die "GCC Version Mismatch." 184 die "GCC Version Mismatch."
135 fi 185 fi
136} 186}
137 187
188# @FUNCTION: use_m
189# @RETURN: true or false
190# @DESCRIPTION:
191# It checks if the kernel version is greater than 2.6.5.
138use_m() { 192use_m() {
139 debug-print-function ${FUNCNAME} $* 193 debug-print-function ${FUNCNAME} $*
140 194
141 # if we haven't determined the version yet, we need too. 195 # if we haven't determined the version yet, we need too.
142 get_version; 196 get_version;
145 # M= instead of SUBDIRS= 199 # M= instead of SUBDIRS=
146 [ ${KV_MAJOR} -eq 2 -a ${KV_MINOR} -gt 5 -a ${KV_PATCH} -gt 5 ] && \ 200 [ ${KV_MAJOR} -eq 2 -a ${KV_MINOR} -gt 5 -a ${KV_PATCH} -gt 5 ] && \
147 return 0 || return 1 201 return 0 || return 1
148} 202}
149 203
204# @FUNCTION: convert_to_m
205# @USAGE: /path/to/the/file
206# @DESCRIPTION:
207# It converts a file (e.g. a makefile) to use M= instead of SUBDIRS=
150convert_to_m() { 208convert_to_m() {
151 debug-print-function ${FUNCNAME} $* 209 debug-print-function ${FUNCNAME} $*
152 210
153 if use_m 211 if use_m
154 then 212 then
158 sed -i 's:SUBDIRS=:M=:g' ${1} 216 sed -i 's:SUBDIRS=:M=:g' ${1}
159 eend $? 217 eend $?
160 fi 218 fi
161} 219}
162 220
221# internal function
222#
223# FUNCTION: update_depmod
224# DESCRIPTION:
225# It updates the modules.dep file for the current kernel.
163update_depmod() { 226update_depmod() {
164 debug-print-function ${FUNCNAME} $* 227 debug-print-function ${FUNCNAME} $*
165 228
166 # if we haven't determined the version yet, we need too. 229 # if we haven't determined the version yet, we need too.
167 get_version; 230 get_version;
178 eend 1 241 eend 1
179 ewarn 242 ewarn
180 fi 243 fi
181} 244}
182 245
246# internal function
247#
248# FUNCTION: update_modules
249# DESCRIPTION:
250# It calls the update-modules utility.
183update_modules() { 251update_modules() {
184 debug-print-function ${FUNCNAME} $* 252 debug-print-function ${FUNCNAME} $*
185 253
186 if [ -x /sbin/modules-update ] && \ 254 if [ -x /sbin/update-modules ] && \
187 grep -v -e "^#" -e "^$" ${D}/etc/modules.d/* >/dev/null 2>&1; then 255 grep -v -e "^#" -e "^$" ${D}/etc/modules.d/* >/dev/null 2>&1; then
188 ebegin "Updating modules.conf" 256 ebegin "Updating modules.conf"
189 /sbin/modules-update 257 /sbin/update-modules
190 eend $? 258 eend $?
259 elif [ -x /sbin/update-modules ] && \
260 grep -v -e "^#" -e "^$" ${D}/etc/modules.d/* >/dev/null 2>&1; then
261 ebegin "Updating modules.conf"
262 /sbin/update-modules
263 eend $?
191 fi 264 fi
192} 265}
193 266
267# internal function
268#
269# FUNCTION: move_old_moduledb
270# DESCRIPTION:
271# It updates the location of the database used by the module-rebuild utility.
194move_old_moduledb() { 272move_old_moduledb() {
195 debug-print-function ${FUNCNAME} $* 273 debug-print-function ${FUNCNAME} $*
196 274
197 local OLDDIR=${ROOT}/usr/share/module-rebuild/ 275 local OLDDIR=${ROOT}/usr/share/module-rebuild/
198 local NEWDIR=${ROOT}/var/lib/module-rebuild/ 276 local NEWDIR=${ROOT}/var/lib/module-rebuild/
204 rm -f ${OLDDIR}/* 282 rm -f ${OLDDIR}/*
205 rmdir ${OLDDIR} 283 rmdir ${OLDDIR}
206 fi 284 fi
207} 285}
208 286
287# internal function
288#
289# FUNCTION: update_moduledb
290# DESCRIPTION:
291# It adds the package to the /var/lib/module-rebuild/moduledb database used by the module-rebuild utility.
209update_moduledb() { 292update_moduledb() {
210 debug-print-function ${FUNCNAME} $* 293 debug-print-function ${FUNCNAME} $*
211 294
212 local MODULEDB_DIR=${ROOT}/var/lib/module-rebuild/ 295 local MODULEDB_DIR=${ROOT}/var/lib/module-rebuild/
213 move_old_moduledb 296 move_old_moduledb
214 297
215 if [[ ! -f ${MODULEDB_DIR}/moduledb ]]; then 298 if [[ ! -f ${MODULEDB_DIR}/moduledb ]]; then
216 [[ ! -d ${MODULEDB_DIR} ]] && mkdir -p ${MODULEDB_DIR} 299 [[ ! -d ${MODULEDB_DIR} ]] && mkdir -p ${MODULEDB_DIR}
217 touch ${MODULEDB_DIR}/moduledb 300 touch ${MODULEDB_DIR}/moduledb
218 fi 301 fi
302
219 if [[ -z $(grep ${CATEGORY}/${PN}-${PVR} ${MODULEDB_DIR}/moduledb) ]]; then 303 if ! grep -qs ${CATEGORY}/${PN}-${PVR} ${MODULEDB_DIR}/moduledb ; then
220 einfo "Adding module to moduledb." 304 einfo "Adding module to moduledb."
221 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${MODULEDB_DIR}/moduledb 305 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${MODULEDB_DIR}/moduledb
222 fi 306 fi
223} 307}
224 308
309# internal function
310#
311# FUNCTION: remove_moduledb
312# DESCRIPTION:
313# It removes the package from the /var/lib/module-rebuild/moduledb database used by
314# the module-rebuild utility.
225remove_moduledb() { 315remove_moduledb() {
226 debug-print-function ${FUNCNAME} $* 316 debug-print-function ${FUNCNAME} $*
227 317
228 local MODULEDB_DIR=${ROOT}/var/lib/module-rebuild/ 318 local MODULEDB_DIR=${ROOT}/var/lib/module-rebuild/
229 move_old_moduledb 319 move_old_moduledb
230 320
231 if [[ -n $(grep ${CATEGORY}/${PN}-${PVR} ${MODULEDB_DIR}/moduledb) ]]; then 321 if grep -qs ${CATEGORY}/${PN}-${PVR} ${MODULEDB_DIR}/moduledb ; then
232 einfo "Removing ${CATEGORY}/${PN}-${PVR} from moduledb." 322 einfo "Removing ${CATEGORY}/${PN}-${PVR} from moduledb."
233 sed -ie "/.*${CATEGORY}\/${PN}-${PVR}.*/d" ${MODULEDB_DIR}/moduledb 323 sed -i -e "/.*${CATEGORY}\/${PN}-${PVR}.*/d" ${MODULEDB_DIR}/moduledb
234 fi 324 fi
235} 325}
236 326
327# @FUNCTION: set_kvobj
328# @DESCRIPTION:
329# It sets the KV_OBJ variable.
237set_kvobj() { 330set_kvobj() {
238 debug-print-function ${FUNCNAME} $* 331 debug-print-function ${FUNCNAME} $*
239 332
240 if kernel_is 2 6 333 if kernel_is 2 6
241 then 334 then
248 # einfo "Using KV_OBJ=${KV_OBJ}" 341 # einfo "Using KV_OBJ=${KV_OBJ}"
249} 342}
250 343
251get-KERNEL_CC() { 344get-KERNEL_CC() {
252 debug-print-function ${FUNCNAME} $* 345 debug-print-function ${FUNCNAME} $*
346
347 if [[ -n ${KERNEL_CC} ]] ; then
348 echo "${KERNEL_CC}"
349 return
350 fi
253 351
254 local kernel_cc 352 local kernel_cc
255 if [ -n "${KERNEL_ABI}" ]; then 353 if [ -n "${KERNEL_ABI}" ]; then
256 # In future, an arch might want to define CC_$ABI 354 # In future, an arch might want to define CC_$ABI
257 #kernel_cc="$(get_abi_CC)" 355 #kernel_cc="$(get_abi_CC)"
261 kernel_cc=$(tc-getCC) 359 kernel_cc=$(tc-getCC)
262 fi 360 fi
263 echo "${kernel_cc}" 361 echo "${kernel_cc}"
264} 362}
265 363
364# internal function
365#
366# FUNCTION:
367# USAGE: /path/to/the/modulename_without_extension
368# RETURN: A file in /etc/modules.d/ (kernel < 2.6) or /etc/modprobe.d/ (kernel >= 2.6)
369# DESCRIPTION:
370# This function will generate and install the neccessary modprobe.d/modules.d file from the
371# information contained in the modules exported parms.
372# (see the variables MODULESD_<modulename>_ENABLED, MODULESD_<modulename>_EXAMPLES,
373# MODULESD_<modulename>_ALIASES, MODULESD_<modulename>_ADDITION and MODULESD_<modulename>_DOCS).
374#
375# At the end the documentation specified with MODULESD_<modulename>_DOCS is installed.
266generate_modulesd() { 376generate_modulesd() {
267 debug-print-function ${FUNCNAME} $* 377 debug-print-function ${FUNCNAME} $*
268
269 # This function will generate the neccessary modules.d file from the
270 # information contained in the modules exported parms
271 378
272 local currm_path currm currm_t t myIFS myVAR 379 local currm_path currm currm_t t myIFS myVAR
273 local module_docs module_enabled module_aliases \ 380 local module_docs module_enabled module_aliases \
274 module_additions module_examples module_modinfo module_opts 381 module_additions module_examples module_modinfo module_opts
275 382
395 fi 502 fi
396 503
397 #----------------------------------------------------------------------- 504 #-----------------------------------------------------------------------
398 505
399 # then we install it 506 # then we install it
507 if kernel_is ge 2 6; then
508 insinto /etc/modprobe.d
509 else
400 insinto /etc/modules.d 510 insinto /etc/modules.d
511 fi
401 newins ${module_config} ${currm_path//*\/} 512 newins ${module_config} ${currm_path//*\/}
402 513
403 # and install any documentation we might have. 514 # and install any documentation we might have.
404 [[ -n ${module_docs} ]] && dodoc ${module_docs} 515 [[ -n ${module_docs} ]] && dodoc ${module_docs}
405 done 516 done
406 eend 0 517 eend 0
407 return 0 518 return 0
408} 519}
409 520
521# internal function
522#
523# FUNCTION: find_module_params
524# USAGE: A string "NAME(LIBDIR:SRCDIR:OBJDIR)"
525# RETURN: The string "modulename:NAME libdir:LIBDIR srcdir:SRCDIR objdir:OBJDIR"
526# DESCRIPTION:
527# Analyze the specification NAME(LIBDIR:SRCDIR:OBJDIR) of one module as described in MODULE_NAMES.
410find_module_params() { 528find_module_params() {
411 debug-print-function ${FUNCNAME} $* 529 debug-print-function ${FUNCNAME} $*
412 530
413 local matched_offset=0 matched_opts=0 test="${@}" temp_var result 531 local matched_offset=0 matched_opts=0 test="${@}" temp_var result
414 local i=0 y=0 z=0 532 local i=0 y=0 z=0
450} 568}
451 569
452# default ebuild functions 570# default ebuild functions
453# -------------------------------- 571# --------------------------------
454 572
573# @FUNCTION: linux-mod_pkg_setup
574# @DESCRIPTION:
575# It checks the CONFIG_CHECK options (see linux-info.eclass(5)), verifies that the kernel is
576# configured, verifies that the sources are prepared, verifies that the modules support is builtin
577# in the kernel and sets the object extension KV_OBJ.
455linux-mod_pkg_setup() { 578linux-mod_pkg_setup() {
456 debug-print-function ${FUNCNAME} $* 579 debug-print-function ${FUNCNAME} $*
457 580
458 linux-info_pkg_setup; 581 linux-info_pkg_setup;
582 require_configured_kernel
459 check_kernel_built; 583 check_kernel_built;
460 strip_modulenames; 584 strip_modulenames;
461 [[ -n ${MODULE_NAMES} ]] && check_modules_supported 585 [[ -n ${MODULE_NAMES} ]] && check_modules_supported
462 set_kvobj; 586 set_kvobj;
463 # Commented out with permission from johnm until a fixed version for arches 587 # Commented out with permission from johnm until a fixed version for arches
473 for i in ${MODULE_IGNORE}; do 597 for i in ${MODULE_IGNORE}; do
474 MODULE_NAMES=${MODULE_NAMES//${i}(*} 598 MODULE_NAMES=${MODULE_NAMES//${i}(*}
475 done 599 done
476} 600}
477 601
602# @FUNCTION: linux-mod_src_compile
603# @DESCRIPTION:
604# It compiles all the modules specified in MODULE_NAMES. For each module the econf command is
605# executed only if ECONF_PARAMS is defined, the name of the target is specified by BUILD_TARGETS
606# while the options are in BUILD_PARAMS (all the modules share these variables). The compilation
607# happens inside ${srcdir}.
608#
609# Look at the description of these variables for more details.
478linux-mod_src_compile() { 610linux-mod_src_compile() {
479 debug-print-function ${FUNCNAME} $* 611 debug-print-function ${FUNCNAME} $*
480 612
481 local modulename libdir srcdir objdir i n myARCH="${ARCH}" myABI="${ABI}" 613 local modulename libdir srcdir objdir i n myABI="${ABI}"
482 ARCH="$(tc-arch-kernel)" 614 set_arch_to_kernel
483 ABI="${KERNEL_ABI}" 615 ABI="${KERNEL_ABI}"
484 616
485 BUILD_TARGETS=${BUILD_TARGETS:-clean module} 617 BUILD_TARGETS=${BUILD_TARGETS:-clean module}
618 strip_modulenames;
619 cd "${S}"
620 for i in ${MODULE_NAMES}
621 do
622 unset libdir srcdir objdir
623 for n in $(find_module_params ${i})
624 do
625 eval ${n/:*}=${n/*:/}
626 done
627 libdir=${libdir:-misc}
628 srcdir=${srcdir:-${S}}
629 objdir=${objdir:-${srcdir}}
630
631 if [ ! -f "${srcdir}/.built" ];
632 then
633 cd ${srcdir}
634 einfo "Preparing ${modulename} module"
635 if [[ -n ${ECONF_PARAMS} ]]
636 then
637 econf ${ECONF_PARAMS} || \
638 die "Unable to run econf ${ECONF_PARAMS}"
639 fi
640
641 # This looks messy, but it is needed to handle multiple variables
642 # being passed in the BUILD_* stuff where the variables also have
643 # spaces that must be preserved. If don't do this, then the stuff
644 # inside the variables gets used as targets for Make, which then
645 # fails.
646 eval "emake HOSTCC=\"$(tc-getBUILD_CC)\" \
647 CROSS_COMPILE=${CHOST}- \
648 LDFLAGS=\"$(get_abi_LDFLAGS)\" \
649 ${BUILD_FIXES} \
650 ${BUILD_PARAMS} \
651 ${BUILD_TARGETS} " \
652 || die "Unable to emake HOSTCC="$(tc-getBUILD_CC)" CROSS_COMPILE=${CHOST}- LDFLAGS="$(get_abi_LDFLAGS)" ${BUILD_FIXES} ${BUILD_PARAMS} ${BUILD_TARGETS}"
653 cd ${OLDPWD}
654 touch ${srcdir}/.built
655 fi
656 done
657
658 set_arch_to_portage
659 ABI="${myABI}"
660}
661
662# @FUNCTION: linux-mod_src_install
663# @DESCRIPTION:
664# It install the modules specified in MODULES_NAME. The modules should be inside the ${objdir}
665# directory and they are installed inside /lib/modules/${KV_FULL}/${libdir}.
666#
667# The modprobe.d/modules.d configuration file is automatically generated if the
668# MODULESD_<modulename>_* variables are defined. The only way to stop this process is by
669# setting MODULESD_<modulename>_ENABLED=no. At the end the documentation specified via
670# MODULESD_<modulename>_DOCS is also installed.
671#
672# Look at the description of these variables for more details.
673linux-mod_src_install() {
674 debug-print-function ${FUNCNAME} $*
675
676 local modulename libdir srcdir objdir i n
677
486 strip_modulenames; 678 strip_modulenames;
487 for i in ${MODULE_NAMES} 679 for i in ${MODULE_NAMES}
488 do 680 do
489 unset libdir srcdir objdir 681 unset libdir srcdir objdir
490 for n in $(find_module_params ${i}) 682 for n in $(find_module_params ${i})
493 done 685 done
494 libdir=${libdir:-misc} 686 libdir=${libdir:-misc}
495 srcdir=${srcdir:-${S}} 687 srcdir=${srcdir:-${S}}
496 objdir=${objdir:-${srcdir}} 688 objdir=${objdir:-${srcdir}}
497 689
498 if [ ! -f "${srcdir}/.built" ];
499 then
500 cd ${srcdir}
501 einfo "Preparing ${modulename} module"
502 if [[ -n ${ECONF_PARAMS} ]]
503 then
504 econf ${ECONF_PARAMS} || \
505 die "Unable to run econf ${ECONF_PARAMS}"
506 fi
507
508 emake HOSTCC="$(tc-getBUILD_CC)" CC="$(get-KERNEL_CC)" LDFLAGS="$(get_abi_LDFLAGS)" \
509 ${BUILD_FIXES} ${BUILD_PARAMS} ${BUILD_TARGETS} \
510 || die "Unable to make ${BUILD_FIXES} ${BUILD_PARAMS} ${BUILD_TARGETS}."
511 touch ${srcdir}/.built
512 cd ${OLDPWD}
513 fi
514 done
515
516 ARCH="${myARCH}"
517 ABI="${myABI}"
518}
519
520linux-mod_src_install() {
521 debug-print-function ${FUNCNAME} $*
522
523 local modulename libdir srcdir objdir i n
524
525 strip_modulenames;
526 for i in ${MODULE_NAMES}
527 do
528 unset libdir srcdir objdir
529 for n in $(find_module_params ${i})
530 do
531 eval ${n/:*}=${n/*:/}
532 done
533 libdir=${libdir:-misc}
534 srcdir=${srcdir:-${S}}
535 objdir=${objdir:-${srcdir}}
536
537 einfo "Installing ${modulename} module" 690 einfo "Installing ${modulename} module"
538 cd ${objdir} || die "${objdir} does not exist" 691 cd ${objdir} || die "${objdir} does not exist"
539 insinto /lib/modules/${KV_FULL}/${libdir} 692 insinto /lib/modules/${KV_FULL}/${libdir}
540 doins ${modulename}.${KV_OBJ} || die "doins ${modulename}.${KV_OBJ} failed" 693 doins ${modulename}.${KV_OBJ} || die "doins ${modulename}.${KV_OBJ} failed"
541 cd ${OLDPWD} 694 cd ${OLDPWD}
542 695
543 generate_modulesd ${objdir}/${modulename} 696 generate_modulesd ${objdir}/${modulename}
544 done 697 done
545} 698}
546 699
700# @FUNCTION: linux-mod_pkg_preinst
701# @DESCRIPTION:
702# It checks what to do after having merged the package.
547linux-mod_pkg_preinst() { 703linux-mod_pkg_preinst() {
548 debug-print-function ${FUNCNAME} $* 704 debug-print-function ${FUNCNAME} $*
549 705
550 [ -d ${IMAGE}/lib/modules ] && UPDATE_DEPMOD=true || UPDATE_DEPMOD=false 706 [ -d "${D}lib/modules" ] && UPDATE_DEPMOD=true || UPDATE_DEPMOD=false
551 [ -d ${IMAGE}/etc/modules.d ] && UPDATE_MODULES=true || UPDATE_MODULES=false 707 [ -d "${D}etc/modules.d" ] && UPDATE_MODULES=true || UPDATE_MODULES=false
552 [ -d ${IMAGE}/lib/modules ] && UPDATE_MODULEDB=true || UPDATE_MODULEDB=false 708 [ -d "${D}lib/modules" ] && UPDATE_MODULEDB=true || UPDATE_MODULEDB=false
553} 709}
554 710
711# @FUNCTION: linux-mod_pkg_postinst
712# @DESCRIPTION:
713# It executes /sbin/depmod and adds the package to the /var/lib/module-rebuild/moduledb
714# database (if ${D}/lib/modules is created) and it runs /sbin/update-modules
715# (if ${D}/etc/modules.d is created).
555linux-mod_pkg_postinst() { 716linux-mod_pkg_postinst() {
556 debug-print-function ${FUNCNAME} $* 717 debug-print-function ${FUNCNAME} $*
557 718
558 ${UPDATE_DEPMOD} && update_depmod; 719 ${UPDATE_DEPMOD} && update_depmod;
559 ${UPDATE_MODULES} && update_modules; 720 ${UPDATE_MODULES} && update_modules;
560 ${UPDATE_MODULEDB} && update_moduledb; 721 ${UPDATE_MODULEDB} && update_moduledb;
561} 722}
562 723
724# @FUNCTION: linux-mod_pkg_postrm
725# @DESCRIPTION:
726# It removes the package from the /var/lib/module-rebuild/moduledb database but it doens't
727# call /sbin/depmod and /sbin/update-modules because the modules are still installed.
563linux-mod_pkg_postrm() { 728linux-mod_pkg_postrm() {
564 debug-print-function ${FUNCNAME} $* 729 debug-print-function ${FUNCNAME} $*
565 remove_moduledb; 730 remove_moduledb;
566} 731}

Legend:
Removed from v.1.70  
changed lines
  Added in v.1.89

  ViewVC Help
Powered by ViewVC 1.1.20